local L = AceLibrary("AceLocale-2.2"):new("Elephant")
local Elephant, self = Elephant, Elephant

function Elephant:HandleMessage(event)
	if not self.db.profile.events[event] then return end
	
	local msg
	--[[ Channels ]]
	if event == "CHAT_MSG_CHANNEL" then
		if arg1 == nil or arg2 == nil or arg9 == nil or arg9 == "" then return end
	
		local larg9 = string.lower(arg9)
		local cIndex
		for k,v in pairs(L['generalchats']) do
			if (larg9 == k) or string.find(larg9, k .. " - ") then
				cIndex = k
				break
			end
		end
		if cIndex == nil then cIndex = larg9 end
		
		if not self.db.char.logs[cIndex].enabled then return end
		
		local msg = {
			['time'] = time(),
			['arg1'] = arg1,
			['arg6'] = arg6,
			['arg9'] = arg9
		}
		if arg2 ~= "" then
			msg['arg2'] = arg2
		end
		self:CaptureNewMessage(msg, cIndex)
	elseif event == "CHAT_MSG_CHANNEL_NOTICE" then
		if arg1 == nil or arg9 == nil or arg9 == "" then return end
	
		local larg9 = string.lower(arg9)
		local cIndex
		for k,v in pairs(L['generalchats']) do
			if (larg9 == k) or string.find(larg9, k .. " - ") then
				cIndex = k
				break
			end
		end
		if cIndex == nil then cIndex = larg9 end
		
		if arg1 == "YOU_JOINED" then
			self:InitCustomStructure(cIndex, arg9)
			
			if not self.db.char.logs[cIndex].enabled then return end
			
			self:CaptureNewMessage( { ['type'] = "SYSTEM", ['arg1'] = L['customchat']['join'] } , cIndex)
			if self.db.char.currentlogindex == cIndex then
				self:UpdateCurrentLogButtons()
			end
		end
		if arg1 == "YOU_LEFT" then
			if not self.db.char.logs[cIndex].enabled then return end
			
			self:CaptureNewMessage( { ['type'] = "SYSTEM", ['arg1'] = L['customchat']['leave'] } , cIndex)
			self:CaptureNewMessage( { ['arg1'] = " " } , cIndex)
			if self.db.char.currentlogindex == cIndex then
				self:UpdateCurrentLogButtons()
				self:ForceCurrentLogDeleteButtonStatus(true)
			end
		end
	--[[ Default messages ]]
	else
		local k
		for k in pairs(self.db.profile.events[event].channels) do
			if self.db.char.logs[k].enabled then
				msg = {
					['time'] = time(),
					['type'] = self.db.profile.events[event].type,
					['arg1'] = arg1
				}
				
				--[[
				if msg == CHAT_MSG_CHANNEL then
					
				end
				
				if msg == CHAT_MSG_CHANNEL_NOTICE then
				
				end
				
				if msg == PARTY_LOOT_METHOD_CHANGED then
				
				end
				]]
				
				if	event == "CHAT_MSG_BATTLEGROUND" or
					event == "CHAT_MSG_BATTLEGROUND_LEADER" or
					event == "CHAT_MSG_WHISPER" or
					event == "CHAT_MSG_WHISPER_INFORM" or
					event == "CHAT_MSG_MONSTER_WHISPER" or
					event == "CHAT_MSG_RAID" or
					event == "CHAT_MSG_RAID_LEADER" or
					event == "CHAT_MSG_RAID_WARNING" or
					event == "CHAT_MSG_PARTY" or
					event == "CHAT_MSG_SAY" or
					event == "CHAT_MSG_MONSTER_SAY" or
					event == "CHAT_MSG_YELL" or
					event == "CHAT_MSG_MONSTER_YELL" or
					event == "CHAT_MSG_OFFICER" or
					event == "CHAT_MSG_GUILD" or
					event == "CHAT_MSG_EMOTE" or
					event == "CHAT_MSG_MONSTER_EMOTE"
				then
					msg.arg2 = arg2
				end
				
				if event == "CHAT_MSG_WHISPER" then
					msg.arg6 = arg6
				end
				
				self:CaptureNewMessage(msg, k)
			end
		end
	end
end